searchNodes=[{"ref":"Avrora.html","title":"Avrora","type":"module","doc":"Avrora Getting Started Avrora is an Elixir library for convenient work with AVRO messages and schemas. It was influenced by AvroTurf Ruby gem. Add Avrora to your project To use Avrora with your projects, edit your mix.exs file and add it as a dependency def deps do [ {:avrora, &quot;~&gt; 0.1.0&quot;} ] end Configure The main configuration options is confluent schema registry url and path to locally stored schemas. Add it in your config/confix.exs config :avrora, registry_url: &quot;http://localhost:8081&quot;, # default to `nil` schemas_path: Path.expand(&quot;./priv/schemas&quot;) # default to `./priv/schemas` If you will set registry_url to a non-nil value, then each time we need to find out what schema did you mean (except known and cached) it will be first fetched from the schema registry and in case if it&#39;s not found we will do lookup in the local schemas. In addition schemas which was not found in the registry will be registered on encoding/decoding time. Start new process manually Avrora is using in-memory cache to speed up known schemas lookup {:ok, pid} = Avrora.start_link() Use in supervision tree Avrora supports child specs, so you can use it as part of a supervision tree children = [ Avrora ] Supervisor.start_link(children, strategy: :one_for_one) Basic Usage Let&#39;s say you have this Payment schema stored in a file priv/schemas/io/confluent/Payment.avsc { &quot;type&quot;: &quot;record&quot;, &quot;name&quot;: &quot;Payment&quot;, &quot;namespace&quot;: &quot;io.confluent&quot;, &quot;fields&quot;: [ { &quot;name&quot;: &quot;id&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;amount&quot;, &quot;type&quot;: &quot;double&quot; } ] } encode/2 To encode payment message with Payment.avsc schema message = %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99} {:ok, pid} = Avrora.start_link() {:ok, encoded} = Avrora.encode(message, schema_name: &quot;io.confluent.Payment&quot;) &lt;&lt;8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; decode/2 To decode payment message with Payment.avsc schema message = &lt;&lt;8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; {:ok, pid} = Avrora.start_link() {:ok, decoded} = Avrora.decode(message, schema_name: &quot;io.confluent.Payment&quot;) %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99}"},{"ref":"Avrora.html#child_spec/1","title":"Avrora.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Avrora.html#decode/2","title":"Avrora.decode/2","type":"function","doc":"See Avrora.Encoder.decode/2."},{"ref":"Avrora.html#encode/2","title":"Avrora.encode/2","type":"function","doc":"See Avrora.Encoder.encode/2."},{"ref":"Avrora.html#init/1","title":"Avrora.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Avrora.html#start_link/1","title":"Avrora.start_link/1","type":"function","doc":""},{"ref":"Avrora.Encoder.html","title":"Avrora.Encoder","type":"module","doc":"Encodes and decodes avro messages created with or without extra Schema Registry version."},{"ref":"Avrora.Encoder.html#decode/2","title":"Avrora.Encoder.decode/2","type":"function","doc":"Decodes given message with a schema eather loaded from the local file or from the configured schema registry. Examples ...&gt; payload = &lt;&lt;72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; ...&gt; Avrora.Encoder.decode(payload, schema_name: &quot;io.confluent.Payment&quot;) {:ok, %{&quot;id&quot; =&gt; &quot;00000000-0000-0000-0000-000000000000&quot;, &quot;amount&quot; =&gt; 15.99}}"},{"ref":"Avrora.Encoder.html#encode/2","title":"Avrora.Encoder.encode/2","type":"function","doc":"Encodes given message with a schema eather loaded from the local file or from the configured schema registry. Examples ...&gt; payload = %{&quot;id&quot; =&gt; &quot;00000000-0000-0000-0000-000000000000&quot;, &quot;amount&quot; =&gt; 15.99} ...&gt; Avrora.Encoder.encode(payload, schema_name: &quot;io.confluent.Payment&quot;) {:ok, &lt;&lt;72, 48, 48, 48, 48, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 45, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 48, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt;}"},{"ref":"Avrora.HttpClient.html","title":"Avrora.HttpClient","type":"behaviour","doc":"Minimalistic HTTP client with a get/post functionality and built-in JSON encode/decode behaviour."},{"ref":"Avrora.HttpClient.html#c:get/1","title":"Avrora.HttpClient.get/1","type":"callback","doc":""},{"ref":"Avrora.HttpClient.html#c:post/3","title":"Avrora.HttpClient.post/3","type":"callback","doc":""},{"ref":"Avrora.Name.html","title":"Avrora.Name","type":"module","doc":"A wrapper around versioned name the schema. It can handle names like io.confluent.Payment and io.confluent.Payment:42 by using : as a delimiter."},{"ref":"Avrora.Name.html#parse/1","title":"Avrora.Name.parse/1","type":"function","doc":"Parses given name and plits it on name + version by a : delimiter. Examples iex&gt; Avrora.Name.parse(&quot;Payment&quot;) {:ok, %Avrora.Name{name: &quot;Payment&quot;, version: nil}} iex&gt; Avrora.Name.parse(&quot;io.confluent.Payment:42&quot;) {:ok, %Avrora.Name{name: &quot;io.confluent.Payment&quot;, version: 42}}"},{"ref":"Avrora.Name.html#t:t/0","title":"Avrora.Name.t/0","type":"type","doc":""},{"ref":"Avrora.Resolver.html","title":"Avrora.Resolver","type":"module","doc":"Resolves schema names or global ID&#39;s to a specific schema files while keeping memory and registry storage up to date."},{"ref":"Avrora.Resolver.html#resolve/1","title":"Avrora.Resolver.resolve/1","type":"function","doc":"Resolves schema be it&#39;s name and optionally version. A version could be provided by adding : and version number to the name (i.e io.confluent.Payment:5). In case if confluent schema registry url is configured, resolution will take a look there first and in case of failure try to read schema from the configured schemas folder. After schema being resolved it will be stored in memory storage with key equal name and name:version. Also it will be added to the registry if it&#39;s configured. Examples ...&gt; {:ok, avro1} = Avrora.Resolver.resolve(&quot;io.confluent.Payment&quot;) ...&gt; {:ok, avro2} = Avrora.Resolver.resolve(&quot;io.confluent.Payment:42&quot;) ...&gt; avro1.version 42 ...&gt; avro2.version 42 ...&gt; avro1.ex_schema.schema.qualified_names [&quot;io.confluent.Paymen&quot;] ...&gt; avro2.ex_schema.schema.qualified_names [&quot;io.confluent.Paymen&quot;]"},{"ref":"Avrora.Schema.html","title":"Avrora.Schema","type":"module","doc":"A wrapper struct around AvroEx.Schema and Confluent Schema Registry for more convinient use."},{"ref":"Avrora.Schema.html#parse/1","title":"Avrora.Schema.parse/1","type":"function","doc":"Parses a Map payload and converts it to the schema with id, AvroEx representation and Map representation. Examples iex&gt; payload = %{&quot;namespace&quot; =&gt; &quot;io.confluent&quot;, &quot;type&quot; =&gt; &quot;record&quot;, &quot;name&quot; =&gt; &quot;Payment&quot;, &quot;fields&quot; =&gt; [%{&quot;name&quot; =&gt; &quot;id&quot;, &quot;type&quot; =&gt; &quot;string&quot;}, %{&quot;name&quot; =&gt; &quot;amount&quot;, &quot;type&quot; =&gt; &quot;double&quot;}]} iex&gt; {:ok, avro} = Avrora.Schema.parse(payload) iex&gt; avro.ex_schema.schema.qualified_names [&quot;io.confluent.Payment&quot;] iex&gt; Map.get(avro.raw_schema, &quot;name&quot;) &quot;Payment&quot;"},{"ref":"Avrora.Schema.html#t:t/0","title":"Avrora.Schema.t/0","type":"type","doc":""},{"ref":"Avrora.Storage.html","title":"Avrora.Storage","type":"behaviour","doc":"A general storage behaviour which allows a client to get the schema by a given name or a global ID and store a given schema under a specific name."},{"ref":"Avrora.Storage.html#c:get/1","title":"Avrora.Storage.get/1","type":"callback","doc":""},{"ref":"Avrora.Storage.html#c:put/2","title":"Avrora.Storage.put/2","type":"callback","doc":""},{"ref":"Avrora.Storage.File.html","title":"Avrora.Storage.File","type":"module","doc":"Reads and parse schema from the disk with conventional name resoltion. For instance schema name &lt;namespace&gt;.&lt;namespace&gt;.&lt;name&gt; will be converted to namespace/namespace/name.avsc path."},{"ref":"Avrora.Storage.Memory.html","title":"Avrora.Storage.Memory","type":"module","doc":"Fast in-memory storage of schemas with access by global id or full name."},{"ref":"Avrora.Storage.Memory.html#child_spec/1","title":"Avrora.Storage.Memory.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Avrora.Storage.Memory.html#get/1","title":"Avrora.Storage.Memory.get/1","type":"function","doc":"Retrieve a value by a given key. Examples iex&gt; {:ok, _} = Avrora.Storage.Memory.start_link() iex&gt; Avrora.Storage.Memory.put(&quot;my-key&quot;, %{&quot;hello&quot; =&gt; &quot;world&quot;}) {:ok, %{&quot;hello&quot; =&gt; &quot;world&quot;}} iex&gt; Avrora.Storage.Memory.get(&quot;my-key&quot;) {:ok, %{&quot;hello&quot; =&gt; &quot;world&quot;}} iex&gt; Avrora.Storage.Memory.get(&quot;unknown-key&quot;) {:ok, nil}"},{"ref":"Avrora.Storage.Memory.html#put/2","title":"Avrora.Storage.Memory.put/2","type":"function","doc":"Stores a value with a given key. If the value is already exists it will be replaced. Examples iex&gt; {:ok, _} = Avrora.Storage.Memory.start_link() iex&gt; avro = %Avrora.Schema{id: nil, ex_schema: %AvroEx.Schema{}, raw_schema: %{&quot;k&quot; =&gt; &quot;v&quot;}} iex&gt; Avrora.Storage.Memory.put(&quot;my-key&quot;, avro) {:ok, %Avrora.Schema{id: nil, ex_schema: %AvroEx.Schema{}, raw_schema: %{&quot;k&quot; =&gt; &quot;v&quot;}}}"},{"ref":"Avrora.Storage.Memory.html#start_link/1","title":"Avrora.Storage.Memory.start_link/1","type":"function","doc":""},{"ref":"Avrora.Storage.Registry.html","title":"Avrora.Storage.Registry","type":"module","doc":"A small wrapper for Confluent Schema Registry, with as less as possible functionality. Inspired by Schemex."},{"ref":"Avrora.Storage.Registry.html#get/1","title":"Avrora.Storage.Registry.get/1","type":"function","doc":"Fetch a schema by a globally unique ID. FIXME: Can&#39;t use a real docs with iex&gt; because don&#39;t know how to make it work Examples ...&gt; {:ok, avro} = Avrora.Storage.Registry.get(1) ...&gt; avro.schema.schema.qualified_names ...&gt; [&quot;io.confluent.examples.Payment&quot;]"},{"ref":"readme.html","title":"Avrora","type":"extras","doc":"Avrora Getting Started Avrora is an Elixir library for convenient work with AVRO messages and schemas. It was influenced by AvroTurf Ruby gem."},{"ref":"readme.html#add-avrora-to-your-project","title":"Avrora - Add Avrora to your project","type":"extras","doc":"To use Avrora with your projects, edit your mix.exs file and add it as a dependency def deps do [ {:avrora, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#configure","title":"Avrora - Configure","type":"extras","doc":"The main configuration options is confluent schema registry url and path to locally stored schemas. Add it in your config/confix.exs config :avrora, registry_url: &quot;http://localhost:8081&quot;, # default to `nil` schemas_path: Path.expand(&quot;./priv/schemas&quot;) # default to `./priv/schemas` If you will set registry_url to a non-nil value, then each time we need to find out what schema did you mean (except known and cached) it will be first fetched from the schema registry and in case if it&#39;s not found we will do lookup in the local schemas. In addition schemas which was not found in the registry will be registered on encoding/decoding time."},{"ref":"readme.html#start-new-process-manually","title":"Avrora - Start new process manually","type":"extras","doc":"Avrora is using in-memory cache to speed up known schemas lookup {:ok, pid} = Avrora.start_link()"},{"ref":"readme.html#use-in-supervision-tree","title":"Avrora - Use in supervision tree","type":"extras","doc":"Avrora supports child specs, so you can use it as part of a supervision tree children = [ Avrora ] Supervisor.start_link(children, strategy: :one_for_one)"},{"ref":"readme.html#basic-usage","title":"Avrora - Basic Usage","type":"extras","doc":"Let&#39;s say you have this Payment schema stored in a file priv/schemas/io/confluent/Payment.avsc { &quot;type&quot;: &quot;record&quot;, &quot;name&quot;: &quot;Payment&quot;, &quot;namespace&quot;: &quot;io.confluent&quot;, &quot;fields&quot;: [ { &quot;name&quot;: &quot;id&quot;, &quot;type&quot;: &quot;string&quot; }, { &quot;name&quot;: &quot;amount&quot;, &quot;type&quot;: &quot;double&quot; } ] } encode/2 To encode payment message with Payment.avsc schema message = %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99} {:ok, pid} = Avrora.start_link() {:ok, encoded} = Avrora.encode(message, schema_name: &quot;io.confluent.Payment&quot;) &lt;&lt;8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; decode/2 To decode payment message with Payment.avsc schema message = &lt;&lt;8, 116, 120, 45, 49, 123, 20, 174, 71, 225, 250, 47, 64&gt;&gt; {:ok, pid} = Avrora.start_link() {:ok, decoded} = Avrora.decode(message, schema_name: &quot;io.confluent.Payment&quot;) %{&quot;id&quot; =&gt; &quot;tx-1&quot;, &quot;amount&quot; =&gt; 15.99}"}]